#### Linux From Scratch - Version 7.10

### Chapter 6. Installing Basic System Software

- Prev

  Xz-5.2.2

- Next

  Gettext-0.19.8.1

- Up
- Home

# 6.46. Kmod-23

The Kmod package contains libraries and utilities for loading kernel modules

Approximate build time: 0.1 SBU
Required disk space: 10.3 MB

## 6.46.1. Installation of Kmod

Prepare Kmod for compilation:

    ./configure --prefix=/usr          \
                --bindir=/bin          \
                --sysconfdir=/etc      \
                --with-rootlibdir=/lib \
                --with-xz              \
                --with-zlib

The meaning of the configure options:

`--with-xz, --with-zlib`

  These options enable Kmod to handle compressed kernel modules.

`--with-rootlibdir=/lib`

  This option ensures different library related files are placed in the correct directories.

Compile the package:

    make

This package does not come with a test suite that can be run in the LFS chroot environment. At a minimum the git program is required and several tests will not run outside of a git repository.

Install the package, and create symlinks for compatibility with Module-Init-Tools (the package that previously handled Linux kernel modules):

    make install

    for target in depmod insmod lsmod modinfo modprobe rmmod; do
      ln -sfv ../bin/kmod /sbin/$target
    done

    ln -sfv kmod /bin/lsmod

## 6.46.2. Contents of Kmod

Installed programs: depmod (link to kmod), insmod (link to kmod), kmod, lsmod (link to kmod), modinfo (link to kmod), modprobe (link to kmod), and rmmod (link to kmod)
Installed library: libkmod.so

### Short Descriptions

depmod | Creates a dependency file based on the symbols it finds in the existing set of modules; this dependency file is used by modprobe to automatically load the required modules
insmod | Installs a loadable module in the running kernel
kmod | Loads and unloads kernel modules
lsmod | Lists currently loaded modules
modinfo | Examines an object file associated with a kernel module and displays any information that it can glean
modprobe | Uses a dependency file, created by depmod, to automatically load relevant modules
rmmod | Unloads modules from the running kernel
`libkmod` | This library is used by other programs to load and unload kernel modules

- Prev

  Xz-5.2.2

- Next

  Gettext-0.19.8.1

- Up
- Home